﻿using System;
using System.Threading;

namespace FunnyCommon.Shared
{
    public interface IPiGpout : IDisposable
    {
        void WritePin(bool height);
    }

    public static class PiGpoutExtensions
    {
        public static void WritePin(this IPiGpout me, int value)
        {
            me.WritePin(value == 1);
        }

        public static void Pulse(this IPiGpout me, bool valueFrom = false, int? intervalMs = null)
        {
            me.WritePin(valueFrom);
            valueFrom = !valueFrom;
            if (intervalMs.HasValue) Thread.Sleep(intervalMs.Value);
            me.WritePin(valueFrom);
        }
    }
}