﻿using System;
using System.Threading;

namespace FunnyCommon.Shared
{
    public interface IPiGpoutManager : IDisposable
    {
        bool? Allocate(byte pin);

        bool Free(byte pin);

        void WritePin(byte pin, bool height);
    }

    public static class PiGpoutManagerExtensions
    {
        public static void WritePin(this IPiGpoutManager me, byte pin, int height)
        {
            me.WritePin(pin, height == 1);
        }

        public static void Pulse(this IPiGpoutManager me, byte pin, bool valueFrom = false, int? intervalMs = null)
        {
            me.WritePin(pin, valueFrom);
            valueFrom = !valueFrom;
            if (intervalMs.HasValue) Thread.Sleep(intervalMs.Value);
            me.WritePin(pin, valueFrom);
        }
    }
}