﻿using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;
using System.Threading;
using FunnyCommon.Remoting.Networking;
using FunnyLcdJlx1770063.Properties;

namespace FunnyLcdJlx1770063
{
    internal static class Program
    {
        private static void Main(string[] args)
        {
            Console.WriteLine("Preping data...");
            var dataBmp = Resources.blue_tag_icon;

            var bmpMapped = new Bitmap(dataBmp.Width, dataBmp.Height, PixelFormat.Format16bppRgb565);
            using (var g = Graphics.FromImage(bmpMapped))
            {
                g.FillRectangle(Brushes.Black, 0, 0, bmpMapped.Width, bmpMapped.Height);
                g.DrawImage(Resources.blue_tag_icon, 0, 0);
            }

            var data = new byte[dataBmp.Width * dataBmp.Height * 2];

            var lck = bmpMapped.LockBits(new Rectangle(0, 0, dataBmp.Width, dataBmp.Height), ImageLockMode.ReadOnly, PixelFormat.Format16bppRgb565);
            Marshal.Copy(lck.Scan0, data, 0, data.Length);
            bmpMapped.UnlockBits(lck);

#if DEBUG
            var cl = new Client();
            cl.Connect("debugpi", 6910);
#else
            var cl=new Common.Remoting.Local.LocalGpoutManager(new PiGpoutManager(255));
#endif

            Thread.Sleep(100);

            Console.WriteLine("Init Driver...");
            var drv = new Jlx1770063Driver(25, 8, 7, 5, 2, 3, new byte[] { 11, 9, 10, 24, 23, 22, 17, 27 }, cl);

            drv.SetLed(true);
            drv.Flush();

            Console.Write("Working...");

            var dataPix = new ushort[bmpMapped.Width * bmpMapped.Height];
            Buffer.BlockCopy(data, 0, dataPix, 0, data.Length);

            drv.FillColor(64, 64, (ushort)bmpMapped.Width, (ushort)bmpMapped.Height, dataPix);
            drv.Flush();
            int endHere = 0;

            //drv.Flush();
            //for (ushort i = 0; i < 64; i += 5)
            //{
            //    drv.FillColor(i, (ushort)(i * 2), 16, 16, data16X16);
            //}

            //drv.FillColor(49, 65, 16, 16, data16X16);

        }
    }
}