﻿using System;
using System.Linq;
using FunnyCommon.Remoting.Networking;

namespace FunnyLed595
{
    internal static class Prosgram
    {
        private static void Main(string[] args)
        {
            if (args.Length < 1 || args.Length > 8)
            {
                Console.WriteLine("Args cout must 1-8");
                return;
            }

            if (false == args.All(p => p.Length == 8 && p.All(q => q == '0' || q == '1')))
            {
                Console.WriteLine("Args must be binary bytes");
                return;
            }

            Console.WriteLine("Parsing args...");

            var data = new byte[] { 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, };
            args.Select(p => (byte)Convert.ToInt32(p, 2)).ToArray().CopyTo(data, 0);

            Console.WriteLine("Opening GPIO...");

#if DEBUG
            var cl = new Client();
            cl.Connect("debugpi", 6910);
#else
            var cl=new Common.Remoting.Local.LocalGpoutManager(new PiGpoutManager(255));
#endif

            var drv1 = new Led74Hc595Driver(21, 16, 20, cl);

            Console.WriteLine("Start loop...");

            while (true)
            {
                for (var i = 0; i < 4; i++)
                {
                    drv1.WriteByte(data[3 - i + 4]);
                    drv1.WriteByte((byte)(1 << i));

                    drv1.WriteByte(data[3 - i]);
                    drv1.WriteByte((byte)(1 << i));

                    drv1.Flush();
                    //Thread.Sleep(5);
                }
            }
        }
    }
}