﻿using System;
using System.IO;
//using WiringPi;

namespace OledSsd1306
{
    internal class Program
    {
        private static void Main(string[] args)
        {
            var ci = File.ReadAllLines("/proc/cpuinfo");
            foreach (var s in ci) Console.WriteLine(s);

            //var ret = Init.WiringPiSetupGpio();
            //if (ret == -1)
            //{
            //    Console.WriteLine("Init failed: {0}", ret);
            //    return;
            //}

            Console.WriteLine("Init SSD1306...");
            var drv = new OledSsd1306Driver();
            var bm = new BitmapMaker(drv, 16);
            drv.Init();
            Console.WriteLine("Clear");
            drv.Clear();

            //for (int i = 0; i < 1000; i++)
            //{
            //    Console.WriteLine("MakeRandom");
            //    drv.SetRandom();
            //    //Thread.Sleep(500);
            //    drv.Clear();
            //    //Thread.Sleep(500);
            //}

            byte p = 17;

            while (true)
            {
                var str = $"蛋{DateTime.Now:mm:ss.fffff}";

                Console.WriteLine($"Show:{str}");
                bm.Make(str);

                for (byte i = 0; i < 255; i++)
                {
                    drv.SetContrast(i, p);
                    //Thread.Sleep(5);
                }
                for (byte i = 255 - 1; i > 0; i--)
                {
                    drv.SetContrast(i, p);
                    //Thread.Sleep(5);
                }

                //p++;
                //if (p > 0xFE) p = 0;
            }

            Console.WriteLine();
            Console.WriteLine("Press ENTER to exit...");
            Console.ReadLine();

            //drv.DrawString("ABCABC");
        }
    }
}