﻿using System;
using System.Diagnostics;
using System.IO;
using System.IO.Ports;
using System.Threading;

namespace SerialPoller
{
    internal static class Program
    {
        private const string SpName = "/dev/serial0";

        private static void Main(string[] args)
        {
            var ci = File.ReadAllLines("/proc/cpuinfo");
            foreach (var s in ci) Console.WriteLine(s);

            var sp = new SerialPort(SpName, 115200);
            sp.ReadTimeout =
            sp.WriteTimeout = 800;

            init:
            sp.Close();
            sp.Open();

            try
            {
                string readed;
                {
                    var cmd = "INIT";
                    sp.WriteLine(cmd);
                    sp.ReadTo($"#{cmd}$OK");
                }

                var sw = new Stopwatch();
                while (true)
                {
                    {
                        var cmd = "CMD1";
                        var rst = "UNIT1";

                        sw.Restart();
                        sp.WriteLine(cmd);
                        sp.ReadTo($"#{cmd}$");
                        readed = sp.ReadTo(rst);
                        sw.Stop();
                        Console.WriteLine($"{readed} by {sw.ElapsedMilliseconds:N0} ms");
                    }

                    {
                        var cmd = "CMD2";
                        var rst = "UNIT2";

                        sw.Restart();
                        sp.WriteLine(cmd);
                        sp.ReadTo($"#{cmd}$");
                        readed = sp.ReadTo(rst);
                        sw.Stop();
                        Console.WriteLine($"{readed} by {sw.ElapsedMilliseconds:N0} ms");
                    }
                }
            }
            catch (TimeoutException e)
            {
                Thread.Sleep(500);
                goto init;
            }
        }
    }
}