﻿using System;
using System.IO;
using System.Linq;
using System.Threading;
using WiringPi;

namespace WiringPiHc595LedArray2
{
    internal class Program
    {
        private const int PwmMax = 1000;

        private const int PinPwm = 18;


        private const int PinBit = 23;
        private const int PinClk = 22;
        private const int PinFlu = 27;

        private static void Main(string[] args)
        {
            var ci = File.ReadAllLines("/proc/cpuinfo");
            foreach (var s in ci) Console.WriteLine(s);

            var ret = Init.WiringPiSetupGpio();
            if (ret == -1)
            {
                Console.WriteLine("Init failed: {0}", ret);
                return;
            }

            GPIO.pinMode(PinBit, (int)GPIO.GPIOpinmode.Output);
            GPIO.pinMode(PinClk, (int)GPIO.GPIOpinmode.Output);
            GPIO.pinMode(PinFlu, (int)GPIO.GPIOpinmode.Output);

            GPIO.pinMode(PinPwm, (int)GPIO.GPIOpinmode.PWMOutput);
            GPIO.pwmSetClock(2);
            GPIO.pwmSetRange(PwmMax);
            GPIO.pwmWrite(PinPwm, 800);

            var drv595 = new Shift74Hc595DriverLocal(PinBit, PinClk, PinFlu);

            void show(int sleep, params byte[] datas)
            {
                Console.WriteLine($"Bit:{string.Join(" ", datas.Select(x => Convert.ToString(x, 2).PadLeft(8, '0')))}");
                drv595.Write(datas);

                Thread.Sleep(sleep);
            }

            while (true)
            {
                show(200, 0x00, 0x00);
                show(200, 0xFF, 0x00);
                show(200, 0x00, 0xFF);


                //for (var i = 0; i < 16; i++)
                //{
                //    var value = (ushort)(1 << i);

                //    var hi = (byte)(value >> 8);
                //    var low = (byte)(value & 0xFF);

                //    show(200, hi, low);
                //}

                //show(200, 0xFF);
                //show(200, 0);

                //show(200, 0b0000_0001); //
                //show(200, 0b0000_0010);
                //show(200, 0b0000_0100);
                //show(200, 0b0000_1000);
                //show(200, 0b0001_0000);
                //show(200, 0b0010_0000);
                //show(200, 0b0100_0000);
                //show(200, 0b1000_0000);

                //show(200, 0b0000_0001);
                //show(200, 0b0000_0010);
                //show(200, 0b0000_0100);
                //show(200, 0b0000_1000);
                //show(200, 0b0001_0000);
                //show(200, 0b0010_0000);
                //show(200, 0b0100_0000);
                //show(200, 0b1000_0000);

                //show(200, 0xFF, 0xFF);
                //show(200, 0, 0);
                //show(200, 0, 0xFF);
                //show(200, 0xFF, 0);

                //show(200, 0, 0b0000_1111);
                //show(200, 0, 0b1111_0000);

                //show(200, 0, 0b0000_1100);
                //show(200, 0, 0b0011_0000);

                //for (var i = 0; i < 8; i++)
                //{
                //    var value = (ushort)(1 << i);

                //    var hi = (byte)(value >> 8);
                //    var low = (byte)(value & 0xFF);

                //    show(200, hi, low);
                //}

                //for (int i = 0; i < 8; i++)
                //{
                //    var valRed = (byte)(1 << i);
                //    var valBlue = (byte)(valRed - 1);

                //    Console.WriteLine($"Bit:{Convert.ToString(valRed, 2).PadLeft(8, '0')} {Convert.ToString(valBlue, 2).PadLeft(8, '0')}");
                //    drv595.Write(valRed, valBlue);

                //    Thread.Sleep(200);
                //}

                //bool fullRed = false;
                //for (int i = 0; i < 20; i++)
                //{
                //    byte valRed = fullRed ? (byte)0xFF : (byte)0;
                //    byte valBlue = 0;

                //    Console.WriteLine($"Bit:{Convert.ToString(valRed, 2).PadLeft(8, '0')} {Convert.ToString(valBlue, 2).PadLeft(8, '0')}");
                //    drv595.Write(valRed, valBlue);

                //    fullRed = !fullRed;
                //    Thread.Sleep(200);
                //}
            }
        }
    }
}