﻿using System.Collections.Generic;
using System.Linq;
using WiringPi;

namespace WiringPiHc595LedArray2
{
    public class Shift74Hc595DriverLocal
    {
        private readonly int _pinBit;
        private readonly int _pinClk;
        private readonly int _pinFlush;

        public Shift74Hc595DriverLocal(int pinBit, int pinClk, int pinFlush)
        {
            _pinBit = pinBit;
            _pinClk = pinClk;
            _pinFlush = pinFlush;
        }

        public void Write(params byte[] values)
        {
            Write((IEnumerable<byte>)values);
        }

        public void Write(IEnumerable<byte> values)
        {
            GPIO.digitalWrite(_pinFlush, (int)GPIO.GPIOpinvalue.Low);
            foreach (var b in values) GPIO.ShiftOut(b, _pinBit, _pinClk);
            GPIO.digitalWrite(_pinFlush, (int)GPIO.GPIOpinvalue.High);
        }

        public void OffAll(int count)
        {
            Write(new byte[count]);
        }

        public void OnAll(int count)
        {
            Write(Enumerable.Repeat((byte)0xFF, count).ToArray());
        }
    }
}